/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2008.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: include/sgx/core/gamecode/gameobject.hpp

*/

#ifndef SGX_GAMECODE_GAMEOBJECT_HPP
#define SGX_GAMECODE_GAMEOBJECT_HPP	1

class CGameObject : public CGameHandler {
public:
	CGameObject() {}
	CGameObject(CGameObject *p) {
		m_pParent = p;
	}
	//
	virtual CGameObject *getParent() const {
		return m_pParent;
	}
	//
	virtual void setTransform(const sgxMatrix43 &xform) {
		m_Transform = xform;
	}

	virtual void setPosition(const sgxVector3 &pos) {
		m_Transform.setPosition(pos);
	}

	virtual void getPosition(sgxVector3 &pos) const {
		m_Transform.getPosition(pos);
	}

protected:
	CGameObject *m_pParent;
	sgxMatrix43	m_Transform;
};

#endif /* #define SGX_GAMECODE_GAMEOBJECT_HPP */
